<#

    .SYNOPSIS

    .DESCRIPTION
    .PARAMETER

    .EXAMPLE

    .NOTES
    Author: Morten Rønborg
    Date: 22-11-2018
    Last Updated: 22-11-2018
    https://mroenborg.com
#>

################################################
##*=============================================
##* GLOBAL VARIABLES LISTINGS
##*=============================================

# Dot Source library and logging variables
. "$PSScriptRoot\lib.ps1"
$IntuneWinAppUtilPath = "$PSScriptRoot\IntuneWinAppUtil.exe"

##*===============================================
##* END VARIABLE DECLARATION
##*===============================================

#Define the XAML
$MainWindowXAML = Get-MainWindowXAML

#Read the XAML
$MainWindowReader = (New-Object System.Xml.XmlNodeReader $MainWindowXAML)

#Define the shared runspace hastable
$SyncHash = @{}
$SyncHash.Window = [Windows.Markup.XamlReader]::Load($MainWindowReader)

#Add to the hastable
$MainWindowXAML.SelectNodes("//*[@*[contains(translate(name(.),'n','N'),'Name')]]") | ForEach-Object{
    
    #Find all of the form types and add them as members to the SyncHash
    $SyncHash.Add($_.Name,$SyncHash.Window.FindName($_.Name) )
}

#Input 
$SyncHash.btn_inputbrowse.add_click({

    [Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms") | Out-Null
    [System.Windows.Forms.Application]::EnableVisualStyles()
    $browse = New-Object System.Windows.Forms.OpenFileDialog
	$browse.ShowDialog()

    $SyncHash.tbx_inputpath.Text = $browse.FileName

})

#Output
$SyncHash.btn_outputbrowse.add_click({

    [Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms") | Out-Null
    [System.Windows.Forms.Application]::EnableVisualStyles()
    $browse = New-Object System.Windows.Forms.FolderBrowserDialog
    $browse.SelectedPath = "$PSScriptRoot"
    $browse.ShowNewFolderButton = $true
    $browse.Description = "Select output folder for the intunewim file to be created"
    $browse.ShowDialog()

    $SyncHash.tbx_outputpath.Text = $browse.SelectedPath

})

#Create
$SyncHash.btn_create.add_click({

    #varliables
    $FilePath = $SyncHash.tbx_inputpath.Text
    $FileName = $FilePath.Split("\")[-1]
    $FolderPath = $FilePath.TrimEnd( $FileName).TrimEnd("\")
    $OutputPath = $SyncHash.tbx_outputpath.Text 

    #Create the file
    Start-Process -FilePath $IntuneWinAppUtilPath -ArgumentList "-c `"$FolderPath`" -s `"$FileName`" -o `"$OutputPath`"" -Wait

})

#Set output to current direcory
$SyncHash.tbx_outputpath.Text = $PSScriptRoot

#Show dialog
$SyncHash.Window.ShowDialog()| Out-Null